package sun.security.acl;

import java.util.Enumeration;
import java.security.acl.LastOwnerException;
import java.security.acl.NotOwnerException;
import java.security.Principal;
import java.security.acl.Group;
import java.security.acl.Owner;

public class OwnerImpl implements Owner
{
    private Group ownerGroup;
    
    public OwnerImpl(Principal principal) {
        (this.ownerGroup = new GroupImpl("AclOwners")).addMember(principal);
    }
    
    public synchronized boolean addOwner(Principal principal, Principal principal2) throws NotOwnerException {
        if (!this.isOwner(principal)) {
            throw new NotOwnerException();
        }
        this.ownerGroup.addMember(principal2);
        return false;
    }
    
    public synchronized boolean deleteOwner(Principal principal, Principal principal2) throws NotOwnerException, LastOwnerException {
        if (!this.isOwner(principal)) {
            throw new NotOwnerException();
        }
        Enumeration<Object> members = this.ownerGroup.members();
        members.nextElement();
        if (members.hasMoreElements()) {
            return this.ownerGroup.removeMember(principal2);
        }
        throw new LastOwnerException();
    }
    
    public synchronized boolean isOwner(Principal principal) {
        return this.ownerGroup.isMember(principal);
    }
}
